// Test all the sorting routines in package DataStructures

import weiss.util.Random;
//import java.util.Random;

public class TestSort {

    private static final int NUM_ITEMS = 20;
    private static int theSeed = 1;

    /**
     * Randomly rearrange an array.
     * The random numbers used depend on the time and day.
     * @param a the array.
     */
    public static final <AnyType> void permute(AnyType[] a) {
        Random r = new Random();

        for (int j = 1; j < a.length; j++) {
            Sort.swapReferences(a, j, r.nextInt(0, j));
        }
    }

    public static void checkSort(Integer[] a) {
        for (int i = 0; i < a.length; i++) {
            if (a[ i] != i) {
                System.out.println("Error at " + i);
            }
        }
        System.out.println("Finished checksort");
    }

    private static void showArray(Integer[] a) {
        System.out.print("index: ");
        for (int i = 0; i < a.length; i++) {
            System.out.printf("  %d", i);
        }
        System.out.println();
        System.out.print("data: ");
        for (int i = 0; i < a.length; i++) {
            System.out.printf("  %d", a[i]);
        }
        System.out.println();
    }

    public static void main(String[] args) {
        Integer[] a = new Integer[NUM_ITEMS];
        for (int i = 0; i < a.length; i++) {
            a[ i] = i;
        }

//        for( theSeed = 0; theSeed < 20; theSeed++ )
//        {
/*            permute( a );
        Sort.insertionSort( a );
        checkSort( a );
        
        permute( a );
        Sort.heapsort( a );
        checkSort( a );
        
        permute( a );
        Sort.shellsort( a );
        checkSort( a );
        
        permute( a );
        Sort.mergeSort( a );
        checkSort( a );
*/        
        permute( a );
        System.out.println("Array content after permute(): ");
        showArray(a);
        Sort.quicksort( a );
        System.out.println("Array content after sort: ");
        showArray(a);        
        checkSort( a );

/*        
        permute(a);
        Sort.quickSelect(a, NUM_ITEMS / 2);
        System.out.println(a[ NUM_ITEMS / 2 - 1] + " is " + NUM_ITEMS / 2 + "th smallest");
*/
//        }
    } //main
} //class

